#pragma once
#ifndef __Pointer_H__
#define __Pointer_H__

class Pointer
	: public InputResponder,
	  //public Attachable<GestureRecognizer>
	  public MutuallyAttachable<Pointer, GestureRecognizer>
{
public:
	bool ProcessEvent(InputEvent & InputEvent) override;

	void ProcessTimePassed(const double TimePassed) override;

	virtual uint8 GetDeviceCategory() const = 0;
	
	//WidgetMapping & GetWidgetMapping();
	GestureRecognizer *		m_GestureRecognizerTEST;

protected:
	Pointer(InputResponder & InputResponder, const uint8 DeviceCategory);
	virtual ~Pointer();
	
	void ProcessActivation(InputEvent & InputEvent);
	void ProcessDeactivation(InputEvent & InputEvent);

	bool IsActive();

private:
	Pointer(const Pointer &) = delete;
	Pointer & operator =(const Pointer &) = delete;

	uint8				m_DeviceCategory;

	bool				m_IsActive;
	PointerState		m_PointerState;

	//WidgetMapping		m_WidgetMapping;
	InputResponder &	m_InputResponder;
	
public:
	auto GetPointerState() -> const PointerState &;
	auto ModifyPointerState() -> PointerState &;
};

#endif // __Pointer_H__
