#include "../Main.h"

#if 0
WidgetMapping::WidgetMapping()
	: PointerInputListener(),
	  m_HoverWidget(nullptr),
	  m_ActiveWidget(nullptr),
	  m_Entries()
{
}

WidgetMapping::~WidgetMapping()
{
}

void WidgetMapping::AddMapping(Widget * Widget)
{
	//Widget->SetActiveWidgetPointer(&m_ActiveWidget);

	m_Entries.push_back(Widget);
}

// TODO: Consider moving this to AddMapping()
// Call this function after all modules are added, it makes sure to enable one of them if it should get enabled
void WidgetMapping::DoneAdding()
{
	// TODO
}

void WidgetMapping::RemoveAllMappings()
{
	// Deactivate the current m_ActiveWidget if it was removed
	if (nullptr != m_ActiveWidget)
	{
		ChangeActiveWidget(nullptr);
	}

	m_Entries.clear();
}

void WidgetMapping::ProcessPointerCreation(Pointer * Pointer)
{
}

void WidgetMapping::ProcessPointerDeletion(Pointer * Pointer)
{
	RemoveHoverPointer(Pointer);
}

void WidgetMapping::ProcessPointerActivation(Pointer * Pointer)
{
}

void WidgetMapping::ProcessPointerDeactivation(Pointer * Pointer)
{
}

void WidgetMapping::ProcessButton(Pointer * Pointer, Input::InputId ButtonId, bool Pressed)
{
	if (nullptr == m_ActiveWidget)
	{
		for (auto & Entry : m_Entries)
		{
			Entry->ProcessButton(Pointer, ButtonId, Pressed);
		}
	}
	else
	{
		m_ActiveWidget->ProcessButton(Pointer, ButtonId, Pressed);
	}
}

void WidgetMapping::ProcessSlider(Pointer * Pointer, Input::InputId SliderId, double MovedAmount)
{
	if (nullptr == m_ActiveWidget)
	{
		for (auto & Entry : m_Entries)
		{
			Entry->ProcessSlider(Pointer, SliderId, MovedAmount);
		}
	}
	else
	{
		m_ActiveWidget->ProcessSlider(Pointer, SliderId, MovedAmount);
	}
}

void WidgetMapping::ProcessAxis(Pointer * Pointer, Input::InputId AxisId, Input::AxisState AxisState)
{
}

void WidgetMapping::Process2Axes(Pointer * Pointer, Input::InputId FirstAxisId, Input::AxisState AxisState[2])
{
}

void WidgetMapping::ProcessCharacter(Pointer * Pointer, int Character)
{
}

void WidgetMapping::ProcessTimePassed(const double TimePassed)
{
	for (auto & Entry : m_Entries)
	{
		Entry->ProcessTimePassed(TimePassed);
	}
}

void WidgetMapping::RequestActivation(Widget * CandidateWidget)
{
	if (nullptr == m_ActiveWidget)
	{
		ChangeActiveWidget(CandidateWidget);
	}
}

void WidgetMapping::RequestDeactivation(Widget * CandidateWidget)
{
	if (m_ActiveWidget == CandidateWidget)
	{
		ChangeActiveWidget(nullptr);
	}
}

Widget * WidgetMapping::GetActiveWidget()
{
	return m_ActiveWidget;
}

void WidgetMapping::RemoveHoverPointer(Pointer * Pointer)
{
	for (auto & Entry : m_Entries)
	{
		Entry->RemoveHoverPointer(Pointer);		// TODO: Maybe only remove/add when there's change, rather than starting from scratch each time
	}
}

void WidgetMapping::ChangeActiveWidget(Widget * ActiveWidget)
{
/*if (nullptr == ActiveModule) printf("ChangeActiveModule(nullptr)\n");
else if (typeid(UnrealCameraModule) == typeid(*ActiveModule)) printf("ChangeActiveModule(UnrealCameraModule)\n");
else if (typeid(WidgetModule) == typeid(*ActiveModule)) printf("ChangeActiveModule(WidgetModule)\n");
else if (typeid(TypingModule) == typeid(*ActiveModule)) printf("ChangeActiveModule(TypingModule)\n");*/

	if (m_ActiveWidget == ActiveWidget) {
		std::cerr << "Exception: ChangeActiveWidget() called with same active widget.\n";
		throw 0;
	}

	if (nullptr != m_ActiveWidget) m_ActiveWidget->ProcessDeactivation();
	m_ActiveWidget = ActiveWidget;
	if (nullptr != ActiveWidget) ActiveWidget->ProcessActivation();

	g_InputManager->SetMouseCursorVisibility(nullptr == m_ActiveWidget || m_ActiveWidget->ShouldMouseCursorVisible());
}
#endif
