template <typename T, typename U> MutuallyAttachable<T, U>::MutuallyAttachable()
{
}

template <typename T, typename U> MutuallyAttachable<T, U>::~MutuallyAttachable()
{
	for (auto & Attached : m_Attached)
	{
		static_cast<MutuallyAttachable<U, T> *>(Attached)->DetachWithoutReciprocating(*this);
	}
}

//template <typename T, typename U> auto MutuallyAttachable<T, U>::GetAttached() -> decltype((m_Attached))
//template <typename T, typename U> auto MutuallyAttachable<T, U>::GetAttached() -> const std::set<MutuallyAttachable<U, T> *> &
template <typename T, typename U> auto MutuallyAttachable<T, U>::GetAttached() -> const std::set<U *> &
{
	return m_Attached;
}

template <typename T, typename U> void MutuallyAttachable<T, U>::CreateConnection(MutuallyAttachable<T, U> & MutuallyAttachable0, MutuallyAttachable<U, T> & MutuallyAttachable1)
{
	MutuallyAttachable0.AttachWithoutReciprocating(MutuallyAttachable1);
	MutuallyAttachable1.AttachWithoutReciprocating(MutuallyAttachable0);
}

template <typename T, typename U> void MutuallyAttachable<T, U>::DestroyConnection(MutuallyAttachable<T, U> & MutuallyAttachable0, MutuallyAttachable<U, T> & MutuallyAttachable1)
{
	MutuallyAttachable0.DetachWithoutReciprocating(MutuallyAttachable1);
	MutuallyAttachable1.DetachWithoutReciprocating(MutuallyAttachable0);
}

template <typename T, typename U> void MutuallyAttachable<T, U>::AttachWithoutReciprocating(MutuallyAttachable<U, T> & MutuallyAttachable)
{
	m_Attached.insert(static_cast<U *>(&MutuallyAttachable));
}

template <typename T, typename U> void MutuallyAttachable<T, U>::DetachWithoutReciprocating(MutuallyAttachable<U, T> & MutuallyAttachable)
{
	m_Attached.erase(static_cast<U *>(&MutuallyAttachable));
}
