#include "Main.h"

OpenGLStream::OpenGLStream(Vector2n CaretPosition)
	: m_CaretPosition(CaretPosition),
	  m_LineStartX(CaretPosition.X())
{
}

OpenGLStream::~OpenGLStream()
{
}

OpenGLStream & OpenGLStream::operator << (const Concept & Concept)
{
	DrawInnerBox(m_CaretPosition, Vector2n(charWidth * Concept.m_Concept.size(), lineHeight), Color(233 / 255.0, 239 / 255.0, 250 / 255.0), Color(195 / 255.0, 212 / 255.0, 242 / 255.0));

	if (Concept.HasLabel(26))
		glColor3d(0, 0, 1);
	else
		glColor3d(0, 0, 0);

	OglUtilsPrint(m_CaretPosition.X(), m_CaretPosition.Y(), 0, LEFT, Concept.m_Concept.c_str());
	m_CaretPosition.X() += Concept.m_Concept.length() * charWidth;

	return *this;
}

OpenGLStream & OpenGLStream::operator << (const std::string & String)
{
	glColor3d(0, 0, 0);
	OglUtilsPrint(m_CaretPosition.X(), m_CaretPosition.Y(), 0, LEFT, String.c_str());
	m_CaretPosition.X() += String.length() * charWidth;

	return *this;
}

OpenGLStream & OpenGLStream::operator << (OpenGLStream & (*Function)(OpenGLStream &))
{
	(*Function)(*this);

	return *this;
}

void OpenGLStream::NewLine()
{
	m_CaretPosition.X() = m_LineStartX;
	m_CaretPosition.Y() += lineHeight;
}

OpenGLStream & endl(OpenGLStream & stream)
{
	stream.NewLine();
	
	return stream;
}
