#include "../Main.h"

Widget::Widget(Vector2n Position, Vector2n Dimensions)
	: m_Position(Position),
	  m_Dimensions(Dimensions),
	  //m_HoverPointers()
	  m_Parent(nullptr)
{
}

Widget::~Widget()
{
}

bool Widget::CheckHover()
{
	//return !m_HoverPointers.empty();
	//return false;
	return (nullptr != m_GestureRecognizerTEST && !m_GestureRecognizerTEST->GetAttached().empty());		// TEST
}

bool Widget::CheckActive()
{
	//return (this == WidgetManager.m_ActiveWidget);
	/*for (auto Pointer : m_HoverPointers)
	{
		//if (this == Pointer->GetWidgetMapping().GetActiveWidget())
		{
			return true;
		}
	}*/

	return false;
}

void Widget::ProcessCanvasUpdated()
{
	if (nullptr != m_GestureRecognizerTEST)
	{
		m_GestureRecognizerTEST->ProcessCanvasUpdated();
	}
}

void Widget::SetParent(Canvas & Parent)
{
	m_Parent = &Parent;
}

const Canvas * Widget::GetParent() const
{
	return m_Parent;
}

// Returns true if there is any (even partial) hit
// Returns false if there is no hit whatsoever
bool Widget::HitTest(Vector2n Position, std::list<Widget *> * Hits) const
{
	bool Hit = (   Position.X() >= m_Position.X()
				&& Position.Y() >= m_Position.Y()
				&& Position.X() <= m_Position.X() + m_Dimensions.X()
				&& Position.Y() <= m_Position.Y() + m_Dimensions.Y());

	if (nullptr != Hits && Hit)
	{
		Hits->push_front(const_cast<Widget *>(this));
	}

	return Hit;
}

bool Widget::ShouldActivate() const
{
	// TODO: Figure this out... I can't quite copy ControlModule's approach, because Widgets become active/inactive based on events, not their internal state. Or do they, maybe it should be based on state, which is less error prone (but then how do you something activate 'on click')? Think about this.
	return false;
}

bool Widget::ShouldDeactivate() const
{
	return !ShouldActivate();
}

/*void Widget::AddHoverPointer(Pointer * Pointer)
{
	m_HoverPointers.insert(Pointer);
}

void Widget::RemoveHoverPointer(Pointer * Pointer)
{
	m_HoverPointers.erase(Pointer);
}*/
