#pragma once
#ifndef __Widget_H__
#define __Widget_H__

class Widget
	: public GestureListener
{
public:
	virtual ~Widget();

	virtual void Render(/*WidgetManager & WidgetManager*/) = 0;

	virtual bool HitTest(Vector2n Position, std::list<Widget *> * Hits) const;

	virtual bool ShouldActivate() const;
	virtual bool ShouldDeactivate() const;
	
	virtual bool ShouldMouseCursorVisible() const { return true; }
	
	virtual void ProcessActivation() {}
	virtual void ProcessDeactivation() {}

	//void SetActiveWidgetPointer(Widget ** ActiveWidgetPointer) { m_ActiveWidgetPointer = ActiveWidgetPointer; }
	/*void AddHoverPointer(Pointer * Pointer);
	void RemoveHoverPointer(Pointer * Pointer);*/
	
	virtual void ProcessCanvasUpdated();

	void SetParent(Canvas & Parent);
	const Canvas * GetParent() const;

	std::unique_ptr<GestureRecognizer>		m_GestureRecognizerTEST;		// Owner of none or single gesture recognizer

protected:
	Widget(Vector2n Position, Vector2n m_Dimensions);

	//bool IsActiveExternally() { return (this == *m_ActiveWidgetPointer); }

	bool CheckHover();
	bool CheckActive();

	Vector2n		m_Position;
	Vector2n		m_Dimensions;

private:
	//Widget **				m_ActiveWidgetPointer;
	//std::set<Pointer *>		m_HoverPointers;

	Canvas *			m_Parent;
};

#endif // __Widget_H__
